%global         commit      8489337d43cc2f86f8072ea4f750077771ab85d9
%global         shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           harctoolbox
Version:        1.1.2
Release:        4%{?dist}
Summary:        Programs for analyzing remote control signals

Group:          Applications/Communications
License:        GPLv3+
URL:            https://github.com/bengtmartensson/harctoolboxbundle
BuildArch:      noarch

Source0:        %{url}/archive/%{commit}/harctoolboxbundle-%{shortcommit}.tar.gz
Source1:        irscrutinizer
Source2:        irpmaster
                # Fixes (4) for Fedora shortcomings, can't be upstreamed
Patch1:         0001-Irpmaster-Don-t-use-unpackaged-3.5.2-antlr-plugin.patch
Patch2:         0002-Jirc-Use-ant-to-avoid-need-of-unpackaged-3.5.2-antlr.patch
Patch3:         0003-Dont-validate-Props.xml.patch
Patch4:         0004-Don-t-validate-IrpMaster.xml.patch
Patch5:         0005-Don-t-access-bundled-crystal-icons.patch
Patch6:         0006-Configure-javadoc-plugin.patch

BuildRequires:  antlr-tool
BuildRequires:  antlr32-tool
BuildRequires:  crystal-project
BuildRequires:  dos2unix
BuildRequires:  DecodeIR
BuildRequires:  desktop-file-utils
BuildRequires:  ExchangeIR
BuildRequires:  exec-maven-plugin
BuildRequires:  icoutils
BuildRequires:  java-wakeonlan
BuildRequires:  libappstream-glib
BuildRequires:  m4
BuildRequires:  maven-antrun-plugin
BuildRequires:  maven-dependency-plugin
BuildRequires:  maven-filtering
BuildRequires:  maven-local
BuildRequires:  maven-plugin-build-helper
BuildRequires:  maven-shade-plugin
BuildRequires:  minimal-json
%if %fedora > 22
BuildRequires:  rxtx > 2.2-0.10
Requires:       rxtx > 2.2-0.10
%else
                # Should be > 2.2-12 when rxtx is fixed.
BuildRequires:  rxtx < 2.2-0.12
Requires:       rxtx < 2.2-0.12
BuildRequires:  maven-install-plugin
%endif

BuildRequires:  tonto
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-maven-plugin

Requires:       crystal-project
Requires:       zenity

Provides:       irscrutinizer = %{version}-%{release}
Provides:       irpmaster = %{version}-%{release}


%description
harctoolbox is a set of programs to catch, analyze and create data to/from
infrared remote controls. The package contains two applications:

- irscrutinizer, a GUI tool to make most operations om infrared data.
- irpmaster, a CLI tool which also is the the underpinnings of IrScrutinizer.


%package        javadoc
Summary:        Javadoc for %{name}

%description javadoc
Javadoc API documentation for %{name}.


%package        doc
Summary:        Documentation for %{name}

%description doc
Various generated HTML documentation for %{name}.


%prep
rm -rf native IrScrutinizer/arduino/GirsLite.zip
%setup -qn harctoolboxbundle-%{commit}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
# tonto  and antlr3 are not bundled:
rm IrScrutinizer/src/main/doc/Tonto-license.txt
find . -name ANTLR3_license_bsd.txt -delete
%pom_change_dep gnu.io:RXTX:* org.rxtx:rxtx:2.2 HarcHardware
%pom_remove_dep org.harctoolbox:HarctoolboxBundle:1.0.0 package
%pom_change_dep org.antlr:antlr-runtime:3.5.2 ::3.2 IrpMaster
%pom_change_dep org.antlr:antlr-runtime:3.5.2 ::3.2 Jirc
%pom_disable_module rxtx-2.2pre2h
rm -rf rxtx-2.2*
%pom_disable_module Crystal-Clear-Icons
rm -rf Crystal-Clear-Icons
%pom_remove_dep :Crystal-Clear-Icons IrScrutinizer
sed -i 's/\r//' $(find . -name girr.xsd)
find \( -name '*.jar' -o -name '*.class' \) -delete


%build
# Temporary until rxtx is fixed:
%if %fedora < 23
%mvn_artifact org.rxtx:rxtx:2.2 /usr/share/java/RXTXcomm.jar
xmvn install:install-file -DgroupId=org.rxtx -DartifactId=rxtx -Dversion=2.2 \
                          -Dpackaging=jar -Dfile=/usr/share/java/RXTXcomm.jar
%endif

%mvn_build
%mvn_package *:*:tar.gz:* __noinstall
%mvn_package *:*:*:jar-with-dependencies __noinstall


%install
%mvn_install
install -d %{buildroot}%{_datadir}/harctoolbox/icons
ln -s %{_datadir}/icons/crystal_project \
    %{buildroot}%{_datadir}/harctoolbox/icons/Crystal-Clear

mv package/dist/doc/LICENSE.txt LICENSE-doc.txt
for f in package/dist/*.ini package/dist/exportformats*; do
    install -Dm 644 $f %{buildroot}%{_datadir}/harctoolbox/etc/$(basename $f)
done
install -Dm 644  package/dist/girr.xsd \
    %{buildroot}%{_datadir}/xml/harctoolbox/girr.xsd

install -Dm 755 %{SOURCE1} %{buildroot}%{_bindir}/irscrutinizer
install -Dm 755 %{SOURCE2} %{buildroot}%{_bindir}/irpmaster

install -d %{buildroot}%{_datadir}/applications
desktop-file-install --set-key=Exec --set-value=irscrutinizer \
    --set-icon=babelfish --dir=%{buildroot}%{_datadir}/applications \
    package/dist/irscrutinizer.desktop
for size in 32 48 64 128; do
    mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${size}x${size}/apps
    ln -s ../../../crystal_project/${size}x${size}/apps/babelfish.png \
        %{buildroot}%{_datadir}/icons/hicolor/${size}x${size}/apps/babelfish.png
done

install -Dm 644 appdata.xml \
    %{buildroot}%{_datadir}/appdata/irscrutinizer.appdata.xml

find package/dist/doc -name \*.html -empty -delete


%check
appstream-util validate-relax --nonet \
    %{buildroot}%{_datadir}/appdata/irscrutinizer.appdata.xml


%post
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files -f .mfiles
%license package/LICENSE.txt
%{_datadir}/harctoolbox
%{_datadir}/xml/harctoolbox
%{_datadir}/applications/irscrutinizer.desktop
%{_datadir}/appdata/irscrutinizer.appdata.xml
# The ...hicolor/*/apps... glob does not work. Strange.
%{_datadir}/icons/hicolor/32x32/apps/babelfish.png
%{_datadir}/icons/hicolor/48x48/apps/babelfish.png
%{_datadir}/icons/hicolor/64x64/apps/babelfish.png
%{_datadir}/icons/hicolor/128x128/apps/babelfish.png
%{_bindir}/irscrutinizer
%{_bindir}/irpmaster

%files doc
%license LICENSE-doc.txt
%doc package/dist/doc

%files javadoc -f .mfiles-javadoc
%license LICENSE-doc.txt


%changelog
* Thu Apr 23 2015 Alec Leamas <leamas.alec@gmail.com> - 1.1.2-4
- rebuilt

* Thu Apr 23 2015 Alec Leamas <leamas.alec@gmail.com> - 1.1.2-3
- Add hacks for lack of rxtx >= 2.2-12.

* Mon Apr 20 2015 Alec Leamas <leamas.alec@gmail.com> - 1.1.2-2
- Fix bad icons reference icons/crystal -> icons/Crystal-Clear.

* Fri Apr 17 2015 Alec Leamas <leamas.alec@gmail.com> - 1.1.2-1
- Initial release
- Purging old changelog in https://copr.fedoraproject.org/coprs/leamas/harctoolbox
- Removing native/ and *.zip files in %%prep

